/* ------------------------------------------------
   cette case n'est pas scurise (monstre a proximite, boulet au dessus)  */

   % notSafeCase(Map)


% on se dplace voir la case du dessus
notSafeCase(Map)
:- getPreviousLineSameXInNavMap(Map, NewMap),
   notSafeCaseUp(NewMap), !.
   
   
% on se dplace voir la case de droite
notSafeCase(Map)
:- getNextCaseInNavMap(Map, NewMap),
   notSafeCaseRight(NewMap), !.
   
   
% on se dplace voir la case de gauche
notSafeCase(Map)
:- getPreviousCaseInNavMap(Map, NewMap),
   notSafeCaseLeft(NewMap), !.


% on se dplace voir la case du dessous
notSafeCase(Map)
:- getNextLineSameXInNavMap(Map, NewMap),
   notSafeCaseDown(NewMap), !.
   
   




% la case du dessus est un monstre
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.



% la case du dessus est vide, on se dplace voir encore au dessus
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getPreviousLineSameXInNavMap(Map, NewMap),
   notSafeCaseUpUp(NewMap), !.


% la case du dessus est vide, on va voir a gauche s'il n'y a pas un monstre qui va a droite ou en bas
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du haut est vide
   getPreviousCaseInNavMap(Map, NewMap),   % rcuprer la case en haut  gauche
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsRightOrUnknown(Monster) ; monsterIsDownOrUnknown(Monster)), !.    % ce monstre va vers la droite ou le bas


% la case du dessus est vide, on va voir a droite s'il n'y a pas un monstre qui va a gauche ou en bas
notSafeCaseUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du haut est vide
   getNextCaseInNavMap(Map, NewMap),       % rcuprer la case en haut  droite
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsLeftOrUnknown(Monster) ; monsterIsDownOrUnknown(Monster)), !.     % ce monstre va vers la gauche ou le bas


% la case du dessus dessus est un boulet ou un diamant
notSafeCaseUpUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   ( getCaseType(Case, pierre) ; getCaseType(Case, diam) ), !.


% la case du dessus dessus est un monstre qui va vers le bas ou qui n'a pas de direction
notSafeCaseUpUp(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsDownOrUnknown(Monster), !.







% la case du dessous est un monstre
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case du dessous est vide, on se dplace voir encore au dessous
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getNextLineSameXInNavMap(Map, NewMap),
   notSafeCaseDownDown(NewMap), !.


% la case du dessous est vide, on va voir a gauche s'il n'y a pas un monstre qui va a droite ou en haut
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du dessous est vide
   getPreviousCaseInNavMap(Map, NewMap),   % rcuprer la case en bas  gauche
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsRightOrUnknown(Monster) ; monsterIsTopOrUnknown(Monster)), !.    % ce monstre va vers la droite ou le haut


% la case du dessous est vide, on va voir a droite s'il n'y a pas un monstre qui va a gauche ou en haut
notSafeCaseDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),                % la case du bas est vide
   getNextCaseInNavMap(Map, NewMap),       % rcuprer la case en bas  droite
   getCurrentCaseInNavMap(NewMap, NewCase),
   getCaseType(NewCase, monstre),          % cette case est un monstre
   getMonsterFromCase(NewCase, Monster),
   (monsterIsLeftOrUnknown(Monster) ; monsterIsTopOrUnknown(Monster)), !.     % ce monstre va vers la gauche ou le haut


% la case du dessous dessous est un monstre qui va vers le haut ou qui n'a pas de direction
notSafeCaseDownDown(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsTopOrUnknown(Monster), !.







% la case de gauche est un monstre
notSafeCaseLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case de gauche est vide, on se dplace voir encore  gauche
notSafeCaseLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getPreviousCaseInNavMap(Map, NewMap),
   notSafeCaseLeftLeft(NewMap), !.


% la case de gauche gauche est un monstre qui va vers la droite ou qui n'a pas de direction
notSafeCaseLeftLeft(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsRightOrUnknown(Monster), !.








% la case de droite est un monstre
notSafeCaseRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre), !.


% la case de droite est vide, on se dplace voir encore  droite
notSafeCaseRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, vide),
   getNextCaseInNavMap(Map, NewMap),
   notSafeCaseRightRight(NewMap), !.


% la case de droite droite est un monstre qui va vers la gauche ou qui n'a pas de direction
notSafeCaseRightRight(Map)
:- getCurrentCaseInNavMap(Map, Case),
   getCaseType(Case, monstre),
   getMonsterFromCase(Case, Monster),
   monsterIsLeftOrUnknown(Monster), !.